(*-----------#pc-version-----------------------------------------------------*)
(*
implementation
uses sys;
*)
(*-----------#pc-version-----------------------------------------------------*)

(*-----------#unix-version-----------------------------------------------------*)
#include "syst.h"
#include "tt1.h"
#include "tt2.h"
#include "tt3.h"
#include "tt4.h"
#include "tt5.h"
#include "calctet.h" 
#include "calctet1.h" 
#include "util.h"
#include "sys.h" 
#include "io.h" 
#include "mon.h" 
#include "part.h" 
#include "cspecial.h"
(*-----------#unix-version-----------------------------------------------------*)
(* 1.  Feb. 10, 1990.  Changed initsominput because vernames no longer
of length 2.  Changed output of partials. *) 

type timearray = array[1..maxdepth] of double;
     deptharray = array[1..maxdepth] of integer;
var numinlist,width: integer; numvisited,lastchecked: real;
    topscore: real; maxlevel: integer;
    expectednum,expectedtime,endtime,starttime: timearray; lasttime: double;
    numatlevel,widths,currentbranch: deptharray; 

procedure printimplist(impbegin: implist);
var curpos: implist;
begin
   curpos := impbegin;
   twriteeoln(output);twriteeoln(output);
   while curpos <> nil do
     begin
        twriteint(output,curpos^.i);twrite(output,' |');
	twriteint(output,curpos^.j);twrite(output,' |');
	twriteint(output,curpos^.k);twrite(output,' |');
	twriteint(output,curpos^.l);twrite(output,' |');
	twriteint(output,curpos^.pattern);
	twriteeoln(output);
        curpos := curpos^.fwd;
     end;
end;

procedure initpaths(level: integer); 
var a,b,limit: integer;
 begin
   if (max < maxvertex) then limit := max + 1 else limit := max;
   for a:= 1 to limit do
      for b:= 1 to limit do
	 begin
	    disposepathslist(paths1^[a,b],level);
	    if a <= b then disposetreklist(treks1^[a,b],level)
	    else treks1^[a,b] := treks1^[b,a];
            if corrimpl^[a,b] = level + 1 then 
                  corrimpl^[a,b] := notthere;
            if corrimpl^[b,a] = level + 1 then corrimpl^[b,a] := notthere;
	 end;
 end;

procedure disposelist(var impbegin,impend: implist); 
var curpos,next: implist; 
begin
   curpos := impbegin;
   if curpos <> nil then next := curpos^.fwd;
   while curpos <> nil do
     begin
       dispose(curpos);
       curpos := next;
       if curpos <> nil then next := curpos^.fwd;
     end;
   impbegin := nil; impend := nil; 
end;

function newimp(i,j,k,l,pattern: vertextype; prob: real): implist; 
var temp: implist; 
begin
  new(temp);
  temp^.i := i; temp^.j := j; temp^.k := k; temp^.l := l;
  temp^.pattern := pattern; temp^.fwd := nil; temp^.back := nil;
  temp^.prob := prob;
  newimp := temp;
end;

procedure addimplied(beginadd,endadd: implist; var impbegin,impend: implist); 
begin
 if endadd <> nil then
   begin
      endadd^.fwd := impbegin;
      if impbegin <> nil then impbegin^.back := endadd;
      impbegin := beginadd;
      if impend = nil then impend := endadd;
   end; 
end;

function removeimplied(remove: implist; var impbegin,impend: implist): implist; 
begin
 if remove <> nil then
   begin
     if remove^.back <> nil then remove^.back^.fwd := remove^.fwd
     else impbegin := remove^.fwd;
     if remove^.fwd <> nil then remove^.fwd^.back := remove^.back
     else impend := remove^.back;
     remove^.back := nil;
     remove^.fwd := nil;
   end;
 removeimplied := remove; 
end;

procedure disposemodellist(var amodel,lastmodel: modelptr);
(* this procedure disposes of a list of models. *)
label 999; 
var temp: modelptr;

begin (* disposemodellist *)
   lastmodel := nil;
   if amodel <> nil then
	 begin
	    temp := amodel^.fwd;
            while (amodel <> nil) do
	       begin
                  if amodel^.edges <> nil then dispose(amodel^.edges);
		  dispose(amodel);
		  amodel := temp;
		  if amodel <> nil then temp := amodel^.fwd
                  else goto 999;
	       end
	 end; (* if *) 
999: end; (* disposemodellist *)

procedure calctetrad(* printout: boolean *);
label 999; 
var num4,i,j,k,l,numtrue: integer; pattern: patterntype; prob: probscores;
    implied: imparray; imp: implist; timestart: double;

begin (* calctetrad *)
  timestart := tgettime;
(*  impheld := 0; impnheld := 0; *)
  if printout then begin twrite(ofilvar,'               Tetrad Equation                        Resid   I  H   Prob|'); 
	twriteeoln(ofilvar); end;
  num4 := 0;
  for i:=1 to numob-3 do
    for j:=i+1 to numob-2 do
      for k:=j+1 to numob-1 do
         for l:=k+1 to numob do
	   begin
	     checkinterrupt;
	     if aaabort then goto 999;
	     num4 := num4 + 1;
             if num4 mod 100 = 0 then
                begin
                   twrite(output,'#|');
                   flush(output);
                end;
             if num4 mod 2100 = 0 then 
               begin
                   twriteeoln(output);
                   flush(output);
                   num4 := 0;
                   if maxtime <> -1 then
                      if (tgettime - timestart) > maxtime then
                        begin
                           errormess('Search aborted because time limits exceeded. |',fatal,false);
                           twriteln(ofilvar,'Search aborted because time limits exceeded. |');
                           goto 999;
                      end;
               end;
             numtrue := 0;
             for pattern := 1 to 3 do
                begin
                  if (pattern <> 3) or (numtrue = 0) then
                     begin
                        comparepair(i,j,k,l,pattern,1,implied[pattern]);
                        if implied[pattern] then numtrue := numtrue + 1;
                     end
                  else if numtrue = 2 then implied[3] := true
                  else if numtrue = 1 then implied[3] := false;
                end;
             hold(i,j,k,l,num4,impheld,impnheld,printout,prob,implied);
             for pattern := 1 to 3 do 
               if implied[pattern] then
                  begin
                      imp := newimp(i,j,k,l,pattern,prob[pattern]);
                      addimplied(imp,imp,impbegin,impend);
                  end;
          end; 
     score := impheld - (weight * impnheld);
     maxscore := impheld;
   twriteeoln(output); 
999: end; (* calctetrad *)

procedure rttrcalctetrad(head: integer; level: integer;
		         common,singleedge: boolean;
                         var chimpheld,chimpnheld: real;
                         var impbegin,impend,rembegin,remend: implist);
		
  (* this procedure is a shortened version of the normal choose4.  it
      it is called from rttrcycler and it calls the procedure hold.
*)

var shortcut,now,removed: boolean; next,curpos,temp: implist; i: integer;

begin (*rttrcalctetrad*)
   i := 1;
   shortcut := true;
   while (i <= numob) and shortcut do
      if paths1^[head,i] <> nil then shortcut := false
      else i := i + 1;
   curpos := impbegin;
   while curpos <> nil do
    begin
     removed := false;
     with curpos^ do
         if (not shortcut) or (i = head) or (j = head) or
            (k = head) or (l = head) or common then
	     begin
		comparepair(i,j,k,l,pattern,level,now);
		if (not now) then
                 begin
                   removed := true;
                   next := curpos^.fwd;
                   temp := removeimplied(curpos,impbegin,impend);
                   addimplied(temp,temp,rembegin,remend);
                   case curpos^.pattern of
                      1: update(curpos,singleedge,
                             ((rho^[i,j] * rho^[k,l])) - ((rho^[i,k] * rho^[j,l])),
                              chimpheld,chimpnheld);
                      2: update(curpos,singleedge,
                             ((rho^[i,l] * rho^[j,k])) - ((rho^[i,j] * rho^[k,l])),
                              chimpheld,chimpnheld);
                      3: update(curpos,singleedge,
                             ((rho^[i,k] * rho^[j,l])) - ((rho^[i,l] * rho^[j,k])),
                              chimpheld,chimpnheld);
                   end;
                  curpos := next;
                 end;
               end;
           if (not removed) then curpos := curpos^.fwd;
     end; 
end; (*rttrcalctetrad*)

procedure hold(* i,j,k,l,tetnum: integer; var impheld,impnheld: real; 
                 var prob: probscores; var imp: imparray  *);
(* this procedure calculates what tetrad equations hold in the data.
   it also calculates the observed residual of each equation, and then 
   the prob for the observed residual being what it is or bigger in procs. 
   calcstat and getprob. *) 
label 999; 
var a,m: integer; locresid: probscores;
    p,q,r,s : real; someimplied: boolean;

procedure updatescore(implied: boolean; prob: real);
begin
   if implied then
     begin
       if (prob >= signif) then impheld := impheld + prob
       else impnheld := impnheld + (1 - prob)
     end;
   if (prob > signif) then bestscore := bestscore + prob
   else worstscore := worstscore + (1 - prob);
end;

begin (*hold*)
   if aaabort then goto 999;
   p := ((rho^[i,j] * rho^[k,l]));
   q := ((rho^[i,k] * rho^[j,l]));
   r := ((rho^[i,l] * rho^[j,k]));
   prob[1]:= 0; prob[2]:= 0; prob[3]:= 0;
   locresid[1] := (p - q);
   calcstat(i,l,j,k,abs(locresid[1]),prob[1],1);
   locresid[3] := (q - r);
   calcstat(i,j,k,l,abs(locresid[3]),prob[3],3);
   locresid[2] := (r - p);
   calcstat(i,k,j,l,abs(locresid[2]),prob[2],2);
   for m := 1 to 3 do updatescore(imp[m],prob[m]);

(* filling the list of eqns with their probs*)
   someimplied := (imp[1]) or (imp[2]) or (imp[3]);
   if printout then
     begin
       twriteeoln(ofilvar);
       outputres(i,j,k,l,i,k,j,l,prob[1],locresid[1],imp[1],prob[1] >= signif);
       outputres(i,k,j,l,i,l,j,k,prob[3],locresid[3],imp[3],prob[3] >= signif);
       outputres(i,l,j,k,i,j,k,l,prob[2],locresid[2],imp[2],prob[2] >= signif);
     end;
999: end; (* hold*)

procedure storesingle(resid: real; rdplus,idminus: integer; tet: boolean); 
begin
  if tet then begin 
	twrite(ofilvar,'Residual: |');
	tpwritereal(ofilvar,resid,8,4,false);
	twrite(ofilvar,' D(I-H):|');
	twriteint(ofilvar,rdplus);
	twrite(ofilvar,' D(H-I): |');
	twriteint(ofilvar,idminus);
	twriteeoln(ofilvar);
	end
  else 	begin
	twrite(ofilvar,'Residual: |');
	tpwritereal(ofilvar,resid,8,4,false);
	twrite(ofilvar,' D(PI-PH):|');
	twriteint(ofilvar,rdplus);
	twrite(ofilvar,' D(PH-PI): |');
	twriteint(ofilvar,idminus);
	twriteeoln(ofilvar);
	end;
end;

procedure storeresults(resid: real; tail,head,rdplus,idminus: integer;
		       var toval: valarray; common: boolean); 
var k,tv: integer;
begin
  tv := pairtoint^[tail,head];
  if common then k := 3 else if tail < head then k := 1 else k := 2;
  toval[tv,k].vttr := resid;
  toval[tv,k].v1 := rdplus;
  toval[tv,k].v2 := idminus; 
end;

procedure storesingle1(chimpheld,chimpnheld: real; rttr: boolean);
begin
 if rttr then
   begin
	twrite(ofilvar,'Score = |');
        tpwritereal(ofilvar,((impheld - chimpheld) - (weight * (impnheld - chimpnheld))),8,4,false);
	twrite(ofilvar,' Maxscore = |');
	tpwritereal(ofilvar,(impheld - chimpheld),8,4,false);
	twriteeoln(ofilvar);
  end;
end;

procedure addedgetomodel(tail,head,level: integer; var corrlast: integer;
                         var impbegin,impend,rembegin,remend: implist; 
                         rttr,singleedge: boolean; 
                         var chimpheld,chimpnheld: real); 
label 999;
var presid: real; prdplus,pidminus,k: integer;
 begin
       numedges := numedges + 1;
       adjacency^[tail,head] := 1;
       chimpheld := 0; chimpnheld := 0;
       addedge(tail,head,treks1,paths1,level,corrlast,chimpheld,chimpnheld);
       if aaabort then goto 999;
       if rttr then
        begin
          rttrcalctetrad(head,level,false,singleedge,chimpheld,chimpnheld,
                        impbegin,impend,rembegin,remend);
         if singleedge then storesingle1(chimpheld,chimpnheld,true)
       end;
999: end;

procedure addcorrtomodel(tail,head,level: integer; var corrlast: integer;
                         var impbegin,impend,rembegin,remend: implist;
			 rttr,singleedge: boolean;
			 var chimpheld,chimpnheld: real);
label 999;
var resid,presid: real; rdplus,idminus,prdplus,pidminus: integer;
begin
       chimpheld := 0; chimpnheld := 0;
       numedges := numedges + 1;
       max := max + 1;
       adjacency^[max,tail] := 1;
       addedge(max,tail,treks1,paths1,level,corrlast,chimpheld,
	       chimpnheld);
       if aaabort then goto 999;
       numedges := numedges + 1;
       adjacency^[max,head] := 1;
       addedge(max,head,treks1,paths1,level,corrlast,chimpheld,
	       chimpnheld);
       if aaabort then goto 999;
       if rttr then 
        begin
         rttrcalctetrad(head,level,true,singleedge,chimpheld,chimpnheld,
                        impbegin,impend,rembegin,remend);
         if singleedge then storesingle1(chimpheld,chimpnheld,true);
       end;
999: end;

procedure restoreimp(var impbegin,impend,rembegin,remend: implist);
begin
   addimplied(rembegin,remend,impbegin,impend);
   rembegin := nil;
   remend := nil;
end;

procedure removeedgefrommodel(tail,head,level,corrfirst,corrlast: integer;
                              var impbegin,impend,rembegin,remend: implist); 
begin
    numedges := numedges - 1;
    adjacency^[tail,head] := notthere;
    initpaths(level);
    restoreimp(impbegin,impend,rembegin,remend); 
end;

procedure removecorrfrommodel(tail,head,level,corrfirst,corrlast: integer;
                              var impbegin,impend,rembegin,remend: implist); 
begin
    numedges := numedges - 2;
    adjacency^[max,head] := notthere;
    adjacency^[max,tail] := notthere;
    max := max - 1;
    initpaths(level);
    restoreimp(impbegin,impend,rembegin,remend); 
end;

procedure insert(var model,curpos,list,listend: modelptr;
                 after,singleedge: boolean);
 begin
   if (curpos = nil) then
     begin
        if listend <> nil then
          begin
            listend^.fwd := model;
            model^.back := listend;
          end
        else list := model;
        listend := model;
     end
   else if after then
     begin
       if (curpos^.fwd <> nil) then curpos^.fwd^.back := model;
       model^.fwd := curpos^.fwd;
       model^.back := curpos;
       curpos^.fwd := model;
       if model^.fwd = nil then listend := model;
     end
   else
     begin
       if (curpos^.back <> nil) then curpos^.back^.fwd := model;
       model^.fwd := curpos;
       model^.back := curpos^.back;
       curpos^.back := model;
       if model^.back = nil then list := model;
     end; end;


function equalscore(score1,score2: real): boolean;
begin
   equalscore := 
       ((score1 >= 0) and 
        ((score1 >= 0.99999 * score2) and (score1 <= 1.00001 * score2))) or
       ((score1 < 0) and
        ((score1 <= 0.99999 * score2) and (score1 >= 1.00001 * score2)));
end;

function lesscore(score1,score2: real): boolean;
begin
   lesscore := 
       (score1 >= 0) and (score1 <= 0.99999 * score2) or 
       (score1 < 0) and (score1 <= 1.00001 * score2);
end;

procedure insertmodel(var model,list,listend: modelptr; singleedge: boolean); 
label 999; 
var curpos: modelptr; foundplace: boolean;
numedges: integer; 
begin
  numinlist := numinlist + 1;
  foundplace := false;
  if model <> nil then
    begin
       numedges := model^.numedges;
       curpos := list;
       while (curpos <> nil) and (not foundplace) do
          begin
             if lesscore(model^.score,curpos^.score) or
               (equalscore(model^.score,curpos^.score) and
                (numedges >= curpos^.numedges)) then
                 begin
                      if curpos = nil then
                          if list = nil then
                            begin
                              insert(model,curpos,list,listend,true,singleedge);
                              goto 999;
                            end
                          else curpos := list
                      else if (curpos^.fwd <> nil) then 
                        curpos := curpos^.fwd
                      else if equalscore(model^.score,curpos^.score) or 
                              (numinlist < 200) then
                         begin
                            insert(model,curpos,list,listend,true,singleedge);
                            goto 999;
                         end
                      else
                         begin
                            dispose(model);
                            numinlist := numinlist - 1;
                            goto 999;
                         end;
                   end
            else foundplace := true;
        end;
   insert(model,curpos,list,listend,false,singleedge);
  end;
999: end;

procedure findplace(var model,list,listend: modelptr; singleedge: boolean); 
var curpos: modelptr; foundplace: boolean; numedges: integer; 
begin
  foundplace := false;
  if model <> nil then
    begin
       numedges := model^.numedges;
       curpos := list;
       while (curpos <> nil) and (not foundplace) do
          begin
             if (model^.score > curpos^.score) or
                ((model^.score = curpos^.score) and
                 ((numedges < curpos^.numedges) or
                  ((numedges = curpos^.numedges) and
                   (model^.maxscore >= curpos^.maxscore)))) then
                    begin
                      insert(model,curpos,list,listend,false,singleedge);
                      foundplace := true;
                    end
              else curpos := curpos^.fwd;
            end;
       if (curpos = nil) then insert(model,curpos,list,listend,false,
		                     singleedge);
     end; 
end;

function formnear(num: real): real; 
begin
   if num > 0 then formnear := percent * num
   else formnear := num/ percent; 
end;

procedure formcandidates(tail,head: integer; common: boolean;
		         chimpheld,chimpnheld: real; var candidates,
		         lastcand: modelptr; impheld,impnheld: real;
                         level: integer); 
var thismod: modelptr; oldscore,thiscore,thismax: real;
    i,j,direction: integer;
 begin
   oldscore := impheld - (weight * impnheld);
   thismax := impheld - chimpheld;
   thiscore := thismax - (weight * (impnheld - chimpnheld));
   if common then direction := 2
   else if (tail < head) then direction := 0
   else direction := 1;
   if thismax >= formnear(topscore) then
      begin
        new(thismod);
        thismod^.fwd := nil; thismod^.back := nil;
        thismod^.singleedge1 := tail;
        thismod^.singleedge2 := head;
        thismod^.numedges := 1;
        thismod^.edges := nil;
        thismod^.score := thiscore;
        thismod^.maxscore := thismax;
        thismod^.direction := direction;
        findplace(thismod,candidates,lastcand,true)
      end
    else if level <> 2 then
      if direction <> 2 then forbiddenadj^[tail,head] := level + 1
      else
        begin
          commonfor^[head,tail] := level + 1;
          commonfor^[tail,head] := level + 1;
        end;
end;

procedure storeresults1(tail,head,direction: integer;
		        var amodel: modelptr;
			score,maxscore: real; numedges: integer;
                        var models,lastmodel: modelptr);
var thismod: modelptr; i,j: integer;
begin
   new(thismod);
   tnewadj(thismod^.edges,fatal);
   thismod^.fwd := nil; thismod^.back := nil;
   for i := 1 to max + lowestlevel - 1 do
     for j := 1 to max + lowestlevel - 1 do
       thismod^.edges^[i,j] := amodel^.edges^[i,j];
   thismod^.singleedge1 := tail;
   thismod^.singleedge2 := head;
   thismod^.score := score;
   thismod^.maxscore := maxscore;
   thismod^.numedges := numedges;
   insertmodel(thismod,models,lastmodel,false); 
end;

procedure rttrcycler(* var candidates,lastcand: modelptr; level:integer;
                       held,nheld: real; corrfirst: integer;
                       var impbegin,impend,rembegin,remend: implist *); 
label 999; 
var gorttr: boolean; i,j,direction,corrlast: integer;
    chimpheld,chimpnheld,thiscore: real; ijconnected: boolean;
begin (*rttrcycler*)
   disposemodellist(candidates,lastcand);
   for i:= 1 to origmax do
    for j:= 1 to origmax do
    if (i <> j) and (i in graphvertices) and (j in graphvertices) then 
     begin
       if maxtime <> -1 then
          if (tgettime - starttime[1]) > maxtime then
             begin
               errormess('Search aborted because time limits exceeded. |',fatal,false);
               twriteln(ofilvar,'Search aborted because time limits exceeded. |');
               goto 999;
             end;
       gorttr := (ll and theoretical[i] and theoretical[j]) or
                 (mm and (not theoretical[i]) and (not theoretical[j])) or
                 (lm and theoretical[i] and (not theoretical[j])) or
                 (ml and (not theoretical[i]) and theoretical[j]);
       if acyclic and (adjacency^[j,i] <> notthere) then
          if (i < j) and (level + 1 < forbiddenadj^[i,j]) then forbiddenadj^[i,j] := level + 1;
       ijconnected :=  (adjacency^[i,j] <> notthere) or 
                       (adjacency^[j,i] <> notthere) or
                       ((commonfor^[i,j] <> notthere) and (level >= commonfor^[i,j]));
       if (adjacency^[i,j] = notthere) and (i <> j) and (i in graphvertices) and
          (j in graphvertices) and gorttr and 
          (not (singleconn and ijconnected)) then 
             begin
             if ((forbiddenadj^[i,j] = notthere) or (level < forbiddenadj^[i,j]-1)) and
              (not (i in temporder[j])) then
              if (not ((numedges + 1) > 10000)) then
               begin
                corrlast := corrfirst;
                addedgetomodel(i,j,level,corrlast,impbegin,impend,rembegin,remend,
                                gorttr,false,chimpheld,chimpnheld);
                thiscore := (held - chimpheld) - weight * (nheld - chimpnheld);
                if thiscore > topscore then topscore := thiscore;
                if gorttr then
                 if (not (acyclic and newcycle)) then
                  formcandidates(i,j,false,chimpheld,
	                         chimpnheld,candidates,lastcand,held,nheld,level)
                 else forbiddenadj^[i,j] := level + 1;
                 removeedgefrommodel(i,j,level,corrfirst,corrlast,
                                     impbegin,impend,rembegin,remend);
                end;
              if (i > j) and comm then
                if ((commonfor^[i,j] = notthere) or (level < commonfor^[i,j]-1)) and
                   (not ((numedges + 2 > 10000) or (max + 1 > maxvertex))) then
                     begin
                      corrlast := corrfirst;
                      addcorrtomodel(i,j,level,corrlast,impbegin,impend,
                                     rembegin,remend,
                                     gorttr,false,chimpheld,chimpnheld);
                      thiscore := (held - chimpheld) - weight * (nheld - chimpnheld);
                      if thiscore > topscore then topscore := thiscore;
                      if gorttr then formcandidates(i,j,true,chimpheld,
			      chimpnheld,candidates,lastcand,held,nheld,level);
       	              removecorrfrommodel(i,j,level,corrfirst,corrlast,
                                          impbegin,impend,rembegin,remend);
                     end;
	  	 checkinterrupt;
	 	 if aaabort then goto 999;
	     end;
       end;
999: end; (*rttrcycler*)

procedure docompare(* wantcommon,wanttet: boolean; tail,head: integer;
                    var impbegin,impend: implist *);
var dummy1,dummy2: real; corrfirst,corrlast: integer;
    rembegin,remend: implist;
begin
 corrfirst := 1; corrlast := 1;
 rembegin := nil;
 remend := nil;
 if wanttet then
   begin
	twriteeoln(ofilvar);
	twrite(ofilvar,'    Tetrad equation                Residual |');
	twrite(ofilvar,'   Impld.     Held     P(diff.)|');
	twriteeoln(ofilvar);
	twriteeoln(ofilvar);
   end;
  if wantcommon then
    begin
      addcorrtomodel(tail,head,2,corrlast,impbegin,impend,rembegin,remend,
                     (ll or ml or mm or lm),true,dummy1,dummy2);
      removecorrfrommodel(tail,head,2,corrfirst,corrlast,impbegin,impend,rembegin,remend);
    end
  else
   begin
    addedgetomodel(tail,head,2,corrlast,impbegin,impend,rembegin,remend,
                  (ll or ml or mm or lm),true,dummy1,dummy2);
    removeedgefrommodel(tail,head,2,corrfirst,corrlast,impbegin,impend,rembegin,remend);
   end;
end;

procedure calcpath(* var adjacency: adjtype; var pathmatrix: pathstype; 
                     level: integer *); 
(* this procedure calculates the path between every pair of variables i and j
   and stores the result in pathmatrix[i,j].  it uses a transitive closure
   algorithm. *)

label 999;
var j,k,i: integer;

begin (* calcpath *)
 for i:=1 to max do
  begin
    pathmatrix^[i,i] := nil;
      for j:=1 to max do
        begin
          if i <> j then
	     begin
              checkinterrupt;
	      if aaabort then goto 999;
	      if adjacency^[i,j] <> notthere then
	        begin
	          new(pathmatrix^[i,j]);
	          pathmatrix^[i,j]^.next := nil;
		  with pathmatrix^[i,j]^ do
		    begin
		      vertices := [i,j];
                      strength := parm^[i,j];
      		      next := nil;
		    end; (* with *)
	      end (* if *)
	   else pathmatrix^[i,j] := nil;
        end; (* if *)
     end; (* for *)
   end; (* for *)
   for k:=1 to max do
      for i:=1 to max do
	 for j:=1 to max do
	    begin
	       if aaabort then goto 999;
	       pathmatrix^[i,j] := plus(pathmatrix^[i,j],timesc(pathmatrix^[i,k],
                                       pathmatrix^[k,j],level,k,true));
	       if pathmatrix^[i,j] <> nil then
		     pathmatrix^[i,j]^.level := 1;
	    end;
999: end; (* Calcpath *)

procedure initsuggested;
begin
    candidates := nil;
    lastcand := nil;
    models := nil;
    lastmodel := nil;
end;

function overtime(curtime: double): boolean;
var realtime: double;
begin
    realtime := (curtime  - starttime[1]);
    if maxtime = -1 then overtime := false
    else overtime := realtime > maxtime;
end;
    
{procedure estimatetime(thistime: double);
var j: integer; sofar,nummodels,avetime,timesofar: double; 
begin
   timesofar := thistime - starttime[1];
   nummodels := 1;
   sofar := 0;
   for j := 2 to lowestlevel do
      begin
         nummodels := nummodels * (numatlevel[j] + widths[j] - currentbranch[j])/numatlevel[j-1];
         expectednum[j] := nummodels + expectednum[j-1];
	 twriteint(output,j);twrite(output,' |');
	 twritereal(output,nummodels);twrite(output,' |');
	 twriteint(output,numatlevel[j]);twrite(output,' |');
	 twriteint(output,widths[j]);twrite(output,' |');
	 twriteint(output,currentbranch[j]);twrite(output,' |');
	 twriteint(output,expectednum[j]);twriteeoln(output);
      end;
    for j := 2 to lowestlevel do
       begin
        sofar := sofar + numatlevel[j];
            expectedtime[j] := (expectednum[j]/expectednum[lowestlevel]) * 
                          timesofar * (expectednum[j]/sofar) - timesofar;
       if expectedtime[j] < 30 then expectedtime[j] := expectedtime[j-1] + 30;
       twritereal(output,timesofar);twrite(output,' |');twritereal(output,sofar);
	twriteeoln(output);
       if ((thistime - lasttime) > 60) then 
          begin
             twrite(output,'The expected time at depth |');
	     twriteint(output,j-1);
	     twrite(output,' is: |');
	     tpwritereal(output,expectedtime[j]/60,8,1,false);
	     twrite(output,' minutes |');twriteeoln(output);
          end;
      end;
   if (thistime - lasttime > 60) then lasttime := thistime;
end;
}
procedure estimatetime(thistime: double);
var j: integer; sofar,nummodels,avetime,timesofar: double; 
begin
   timesofar := thistime - starttime[1];
   if timesofar <> 0 then avetime := numvisited/timesofar
   else avetime := 0;
   nummodels := 1;
   sofar := 0;
   for j := 2 to lowestlevel do
      begin
         nummodels := nummodels * (numatlevel[j] + widths[j] - currentbranch[j])/numatlevel[j-1];
         expectednum[j] := nummodels + expectednum[j-1];

      end;
    for j := 2 to lowestlevel do
       begin
        sofar := sofar + numatlevel[j];
        expectedtime[j] := (expectednum[j] - sofar) * avetime;
        if expectedtime[j] < 10 then expectedtime[j] := expectedtime[j-1] + 10;
        if ((thistime - lasttime) > 60) then 
          begin
             twrite(output,'The expected time at depth |');
	     twriteint(output,j-1);
	     twrite(output,' is: |');
	     tpwritereal(output,(expectedtime[j]/60),8,1,false);
	     twrite(output,' minutes |'); twriteeoln(output);
          end;
      end;
   if (thistime - lasttime > 60) then lasttime := thistime;
end;

procedure followbranch(var amodel: modelptr; var limpbegin,limpend: implist;
		       corrfirst,corrlast,level,nochange: integer; 
                       held,nheld: real; numinskel: integer);
label 999;
var i,j,m,direction,tail,head: integer; rembegin,remend: implist;
    candlist,endofcand,curcandidate: modelptr; stop,resetdepth: boolean;
    chimpheld,chimpnheld,newimpheld,newimpnheld,modelscore,oldscore,
    neartoplevel: real; oldnochange,newlevel,olddepth: integer;
    ratio,timenow,timesofar:real; bob: integer;
begin  {1}
  if level > lowestlevel then lowestlevel := level;
  rembegin := nil;
  remend := nil;
  if level > maxlevel then maxlevel := level;
  currentbranch[level] := 1;
  oldnochange := nochange;
  candlist := nil; endofcand := nil;
  oldscore := held - (weight * nheld);
  resetdepth := false;
  lastchecked := numvisited;
  starttime[level] := tgettime;
  if level <> 2 then 
     begin
        timenow:=tgettime;
        timesofar:=timenow-starttime[1];
        newlevel := level; 
	        estimatetime(timenow);
        repeat
         if maxtime <> -1 then
          if (timesofar/maxtime > 0.3) and (maxtime>timesofar) then
            if (expectedtime[newlevel] <= maxtime) or (newlevel = 2) then
               if(newlevel < lowestlevel) and (not resetdepth) and
                 ((newlevel < depth) or (depth = -1)) then
                   begin
                     depth := newlevel;
                     lowestlevel := depth;
                     twriteeoln(output);
                     twrite(output,'Changing depth to: |');
                     twriteint(output,depth);
                     twriteeoln(output);
                     twriteeoln(output);
                     resetdepth := true;
                   end;
           newlevel := newlevel - 1;
      until (newlevel = 1) or resetdepth;
     if maxtime <> -1 then 
       if (maxtime <= timesofar) then
           begin
              errors := errors + [fatal];
              twrite(ofilvar,'Search aborted because time limits exceeded. |');
              twriteeoln(ofilvar);
           end;
    end
  else twriteln(output,'Adding edge: |');
  rttrcycler(candlist,endofcand,level,held,nheld,corrfirst,
             limpbegin,limpend,rembegin,remend);
  curcandidate := candlist;
  if candlist <> nil then
      if candlist^.score > 0 then 
          neartoplevel := percent * candlist^.score
      else neartoplevel := candlist^.score/ percent;
  stop := false;
  currentbranch[level] := 0;
  widths[level] := 0;
  while (curcandidate <> nil) and (not stop) do 
   if (curcandidate^.score >= neartoplevel) and (widths[level] <= 10000) and
      ((curcandidate^.score > oldscore) or
       ((nochange <= nochangedepth) or (nochangedepth = -1))) then
        begin {2}
          widths[level] := widths[level] + 1;
          if curcandidate^.score <= oldscore then nochange := nochange + 1;
          curcandidate := curcandidate^.fwd;
        end {2}
    else stop := true;
   nochange := oldnochange;
   stop := false;
  curcandidate := candlist;
  while (curcandidate <> nil) and (not stop) and (not aaabort) and
        ((depth = -1) or (level <= depth + 1)) do
   if (curcandidate^.score >= neartoplevel) and (currentbranch[level] < 10000) 
      and ((curcandidate^.score > oldscore) (* or
       ((nochange <= nochangedepth) or (nochangedepth = -1)) *) ) then
     begin {3}
       numvisited := numvisited + 1;
       numatlevel[level] := numatlevel[level] + 1;
       tail := curcandidate^.singleedge1;
       head := curcandidate^.singleedge2;
       endtime[level] := tgettime;
       currentbranch[level] := currentbranch[level] + 1;
       nochange := oldnochange;
       corrlast := corrfirst;
       direction := curcandidate^.direction;
       if direction <> 2 then amodel^.edges^[tail,head] := level + 1
       else
          if (max + 1 > maxvertex) then
             begin
            	twrite(output,'can''t add correlated error |');
          	twriteint(output,tail);
        	twrite(output,' |');
           	twriteint(output,head); twriteeoln(output);
             end
          else
             begin
                amodel^.edges^[max+1,tail] := level + 1;
                amodel^.edges^[max+1,head] := level + 1;
             end;
       if direction <> 2 then 
         begin
           if (level + 1 < forbiddenadj^[tail,head]) or (forbiddenadj^[tail,head] = notthere) then
               forbiddenadj^[tail,head] := level + 1
          end
       else if (level + 1 < commonfor^[tail,head]) or (commonfor^[tail,head] = notthere) then
         begin
           commonfor^[tail,head] := level + 1;
           commonfor^[head,tail] := level + 1;
         end;
       chimpheld := 0; chimpnheld := 0;
       for bob := 1 to 3*level do twritechar(output,' ');
       writename(tail,output);
       if direction <> 2 then twrite(output,' -> |') 
       else twrite(output,' C  |');
       writename(head,output);
       twriteeoln(output);
       if (direction <> 2) then
         addedgetomodel(tail,head,level,corrlast,limpbegin,limpend,rembegin,
                        remend,true,false,chimpheld,chimpnheld)
       else addcorrtomodel(tail,head,level,corrlast,limpbegin,limpend,rembegin,
                           remend,true,false,chimpheld,chimpnheld);
       
       newimpheld := held - chimpheld;
       newimpnheld := nheld - chimpnheld;
       modelscore := newimpheld - (weight * newimpnheld);
(*       if chimpnheld = 0 then nochange := nochange + 1;  *)
       if (modelscore <= oldscore) then nochange := nochange + 1;
       if (modelscore > currentmax) then
          begin {4}
           currentmax := modelscore;
           if currentmax = 0 then currentmax := 0.001;  
                (* so don't divide by zero later *)
          end; {4}
(*       if (curcandidate^.score >= oldscore) then 
          if ((level <= depth) or (depth = -1)) and
             ((nochange <= nochangedepth) or (nochangedepth = -1)) then *)
         if (curcandidate^.score > oldscore) then 
           if ((level <= depth) or (depth = -1)) then
              followbranch(amodel,limpbegin,limpend,corrlast,corrlast,level+1,
                           nochange,newimpheld,newimpnheld,numinskel);
       if (modelscore >= oldscore) and 
          (((currentmax >= 0) and (modelscore >= percent * currentmax)) or
           ((currentmax < 0) and (modelscore >= currentmax/percent))) then
           storeresults1(tail,head,direction,amodel,
                       modelscore,newimpheld,numinskel+level-1,models,lastmodel); 
       if (direction <> 2) then 
           removeedgefrommodel(tail,head,level,corrfirst,corrlast,
                               limpbegin,limpend,rembegin,remend)
       else removecorrfrommodel(tail,head,level,corrfirst,corrlast,
                                limpbegin,limpend,rembegin,remend);
       if (direction <> 2) then amodel^.edges^[tail,head] := notthere
       else 
          begin
            amodel^.edges^[max+1,tail] := notthere;
            amodel^.edges^[max+1,head] := notthere;
          end;
       curcandidate := curcandidate^.fwd;
      end  {3}
    else stop := true;
    for i := 1 to max do
        for j := 1 to max do
            begin
              if forbiddenadj^[i,j] = level + 1 then forbiddenadj^[i,j] := notthere;
              if commonfor^[i,j] = level + 1 then commonfor^[i,j] := notthere;
            end;
999: if aaabort and (level = 2) then
       begin
         writemodellist(candlist,ofilvar);
         twrite(output,'Search aborted. |');
 	 twriteeoln(output);
         twrite(ofilvar,'Search aborted. |');
	 twriteeoln(ofilvar);
        end;
   disposemodellist(candlist,endofcand);
end; {1}

procedure setlistlength(var list,lastlist: modelptr; length: integer);
var i: integer; curpos: modelptr; stop: boolean;
begin
   i := 1;
   curpos := candidates;
   stop := false;
   while (curpos <> nil) and (i < length) do
      begin
         curpos := curpos^.fwd;
         i := i + 1;
      end;
   if curpos <> nil then
     while (not stop) do
       begin
         if curpos^.fwd <> nil then
            if curpos^.fwd^.score = curpos^.score then curpos := curpos^.fwd
            else stop := true
         else stop := true;
       end;
   if i >= length then 
    if curpos <> nil then 
     if curpos^.fwd <> nil then
       begin
         disposemodellist(curpos^.fwd,lastlist);
         lastlist := curpos;
       end;
end;

procedure initsomeinput;
var ch: char; i,j,k,l: integer; foundit: boolean;
begin
    ch := 'A';
    for i := numob + 1 to maxvertex do
        begin
          for j := 1 to namelength - 1 do vernames[i][j] := ' ';
          ch := chr(ord(ch) + 1);
          vernames[i][namelength] := ch;
          theoretical[i] := true;
        end;
    ranpart := false; rantet := false; 
    errors := [];
    curpos := 1;
end;


procedure corrhold;
var i,j: integer; z,prob: real;
begin
  for i := 1 to numob - 1 do
    for j := i + 1 to numob do
      begin
         z := (1/2) * (sqrt(sampsize - 3)) * ln((1 + abs(rho^[i,j])) / 
              (1 - abs(rho^[i,j])));
         getprob(prob,abs(z));
         corrproba^[i,j] := prob;
         if (corrimpl^[i,j] = notthere) then
            begin
                if prob >= signif then impheld := impheld + prob
                else impnheld := impnheld + (1 - prob);
            end;
         if prob >= signif then bestscore := bestscore + prob
         else worstscore := worstscore + (1 - prob);
      end;
end;

procedure calccorr;
var i,j: integer;
begin
   impheld := 0; impnheld := 0; bestscore := 0; worstscore := 0;
   for i := 1 to numob - 1 do
      for j := i + 1 to numob do
        if treks1^[i,j] = nil then corrimpl^[i,j] := notthere
        else corrimpl^[i,j] := 0;
   corrhold;
end;

procedure autosearch;
label 999;
var amodel: modelptr; i,j,k,l,numinskel: integer; c: char; 
    localadj: adjtype; olddepth: integer;
begin
   new(amodel);
   tnewadj(amodel^.edges,fatal);
   for i := 1 to maxvertex do
      for j := 1 to maxvertex do amodel^.edges^[i,j] := notthere;
   tnewadj(localadj,fatal); (* check for enough space *)
   if fatal in errors then goto 999;
   lowestlevel := 2;
   olddepth := depth;
   expectednum[1] := 0;
   for i := 2 to maxdepth do numatlevel[i] := 0;
   numatlevel[1] := 1;
   for i := 1 to maxvertex do 
     for j := 1 to maxvertex do 
        begin
          localadj^[i,j] := adjacency^[i,j];
          if (adjacency^[i,j] <> notthere) and acyclic then
            forbiddenadj^[i,j] := 0;
         end;
   numvisited := 0;
   maxlevel := 0;
   disposemodellist(models,lastmodel);
   numinlist := 0;
   currentmax := score;
   if currentmax = 0 then currentmax := 0.001;
   topscore := score;
    if score > topscore then topscore := score;
     storeresults1(1,2,0,amodel,score,impheld,numinskel,models,lastmodel);
    starttime[1] := tgettime;
    lasttime := starttime[1];
    expectedtime[1] := 0;
    lastchecked := 1;
    followbranch(amodel,impbegin,impend,1,1,2,0,impheld,impnheld,numinskel);
    disposelist(impbegin,impend);  
    rantet := false;
    for i := 1 to maxvertex do 
     for j := 1 to maxvertex do adjacency^[i,j] := localadj^[i,j];
    writemodellist(models,ofilvar);
     dispose(localadj);
999: errors := errors - [fatal];
     depth := olddepth;
    for i := 1 to maxvertex do 
     for j := 1 to maxvertex do 
       begin
          if (commonfor^[i,j] > notthere) or (adjacency^[i,j] <> notthere) then
               commonfor^[i,j] := notthere;
          if (forbiddenadj^[i,j] > notthere) or (adjacency^[i,j] <> notthere) then
                forbiddenadj^[i,j] := notthere;
          corrimpl^[i,j] := 0;
       end;
end;

(*-----------#pc-version-----------------------------------------------------*)
(*
end.
*)
(*-----------#pc-version-----------------------------------------------------*)