(*-----------#pc-version-----------------------------------------------------*)
(*
implementation
uses io,calctet,util,sys;
*)
(*-----------#pc-version-----------------------------------------------------*)

(*-----------#unix-version---------------------------------------------------*)
#include "syst.h"
#include "tt1.h"
#include "tt2.h"
#include "tt3.h"
#include "tt4.h"
#include "tt5.h"
#include "io.h"
#include "sys.h"
#include "util.h"
#include "scal.h"
#include "rsutil.h"
#include "eqs.h"
#include "mon.h"
#include "calctet.h"
#include "cspecial.h"
(*-----------#unix-version---------------------------------------------------)*

(****************************************)
(* from monte *)


function wspace(c: char): boolean;
(* true if c is tab or blank. *)
var tab: char;
begin
   tab := chr(9);
   wspace := (c = ' ') or (c = tab);
end;


procedure readword(* var word: wordtype*);
var c: char; foundwspace: boolean; i: integer;
begin
   readwhitespace;
   for i := 1 to wordlength do word[i] := ' ';
   foundwspace := false;
   i := 1;
   while (not myeoln) and (not foundwspace) and
         (i <= wordlength) do
      begin
        readit(c);
        if (not wspace(c)) then word[i] := c
        else foundwspace := true;
        i := i + 1;
      end;
end;

function matchword(* var word,target: wordtype; maxl:integer): boolean; *);
 var i,max: integer;
     c: char;
     match, foundwhitespace: boolean;
 begin
   i:= 1;
   match:= true;
   if (maxl <= wordlength) then max:= maxl else max:= wordlength;
   repeat
     match:= (uppercase(word[i]) = uppercase(target[i]));
     i:= i+1;
   until ((not match) or (target[i] = '|') or (i > max));
   matchword:= match;
 end;

function isdashedline(*: boolean;*);
 var i: integer;
     c: char;
     match: boolean;
 begin
  i:= 1; match:= true;
  readwhitespace;
  repeat 
    readit(c);
    match:= (c = '-');
    i:= i+1;
  until (not match) or (i > 5);
  isdashedline:= match;
 end;


function iswordonline(* var target: wordtype): boolean; *);
 var found: boolean;
     word: wordtype;
 begin
   found:= false;
   repeat
     readword(word);
     found:= matchword(word,target,wordlength);
   until (found or myeoln);
   curpos:= 1;
   iswordonline:= found;
 end;


  (* true iff first character typed in matches answer wanted. *)
function compareto(* (answanted: char) : boolean; *);
  var c: char; answer: boolean;
  begin
    readttyline(buf); 
    readwhitespace;
    if myeoln then answer:= true
    else 
      begin 
       readit(c);
       answer:= (c = answanted);
      end;
    compareto:= answer;
  end;

procedure readtochar(*target: char*);
  var c: char;
  begin
   repeat 
     readit(c);
   until c = target;
  end;

procedure readtodecimal;
  var c: char;
  begin
   repeat 
     readit(c);
   until c = '.';
   curpos:= curpos-1;
  end;

function getnextnum(*var infile: text; numcats: categorynum): real*);
var undef: boolean; i: integer;
  begin
   readtochar('=');
   readwhitespace;
   i := 0;
   undef := true;
   if (not (buf[curpos] in ['U','u'])) then undef := false;
(*   while (curpos+i <= buflength) and (i <= 4) do
      begin
        if (i = 0) and (not (buf[curpos+i] in ['U','u'])) then undef := false;
        if (i = 1) and (not (buf[curpos+i] in ['N','n'])) then undef := false;
        if (i = 2) and (not (buf[curpos+i] in ['D','d'])) then undef := false;
        if (i = 3) and (not (buf[curpos+i] in ['E','e'])) then undef := false;
        if (i = 4) and (not (buf[curpos+i] in ['F','f'])) then undef := false;
        i := i + 1;
      end; *)
   if undef then 
      begin
         curpos := curpos + 1;
         getnextnum := 1/numcats;
      end
   else getnextnum:= readnum1(infile, false, ignoreall);
  end;

(****************************)
(* from scales *)

(* this prints only the characters in the name, not the
   spaces. *)
procedure pshort(*v: vertextype; var outfile: text*);
  var i: integer; go: boolean;
  begin
   i:= 1;
   go := true;
   while (i <= namelength) and go do
      begin
         go := (vernames[v][i] <> ' ') and (vernames[v][i] <> '|');
         if go then twritechar(outfile,vernames[v][i]);
         i:= i+1;
      end;
  end;


procedure printadj(* var graph: adjtype; var outfile: text *);
var k,l: integer;
begin
   for k := 1 to maxvertex do
      for l := 1 to maxvertex do
        if (k <> l) and (graph^[k,l] <> notthere) then
		begin
		  writename(k,outfile); twrite(outfile,' |');
		  writename(l,outfile); twrite(outfile,' |');
		end;
   twriteeoln(outfile);
end;

procedure printmimout(*var pattern: adjtype; var outfile: text; 
                       var uncertain: uncertaintype*);
var i,j: vertextype;
      found: boolean;
  begin
    found:= false;
    twriteeoln(outfile);
    twriteln(outfile,'--------------------------------------------------|');
    twriteln(outfile,'Pattern for the Structural Model|');
    twriteeoln(outfile);
    for i:= numob+1 to (numlatents + numob - 1) do
      for j:= i+1 to (numlatents + numob) do
        if (pattern^[i,j] <> notthere) or  (pattern^[j,i] <> notthere) then
          begin
            found:= true;
            pshort(i,outfile);
            twrite(outfile,' |');
            if printqmarks and uncertain[i-numob,j-numob] then twrite(outfile,'?|');
            if pattern^[j,i] = into2 then twrite(outfile,'<|') else twrite(outfile,'-|');
            if pattern^[i,j] = into2 then twrite(outfile,'>|') else twrite(outfile,'-|');
            if printqmarks and uncertain[i-numob,j-numob] then twrite(outfile,'?|');
            twrite(outfile,' |');
            pshort(j,outfile);
            twriteeoln(outfile);
          end;
    if not found then twrite(outfile,' - The model is totally disconnected - |');
    twriteeoln(outfile);
    twriteeoln(outfile);
  end; (* printpattern*)

function sizeofset(*verset: vertexset): integer*);
  var i,count: integer;
  begin
    count:= 0;
    for i:= 1 to maxvertex do
      if (i in verset) then count:= count+1;
    sizeofset:= count;
  end;

function parentof(*v: vertextype; var measures: modasclusters): vertextype*);
  var parent: vertextype;
      found: boolean;
  begin
    found:= false;
    parent:= 1;
    repeat
     if v in measures[parent] then found:= true
     else parent:= parent+1;
    until (found or (parent > numlatents));
    parentof:= parent;
  end;


function lmax(i1,i2:longint):longint;
begin
  if i1>i2 then lmax:=i1
  else lmax:=i2;
end;
function lmin(i1,i2:longint):longint;
begin
  if i1>i2 then lmin := i2
  else lmin:=i1;
end;

function choosenum(*setsize,n:integer): longint*);
  var numerator,denomenator:longint;
      i,min,max:integer;
      num:real;
  begin
    numerator:=1;
    denomenator:=1;
    max:=lmax(n,setsize-n);
    min:=lmin(n,setsize-n);
    for i := max+1 to setsize do
       numerator:=numerator * i;
    for i:= 2 to min do
       denomenator:=denomenator * i;
    choosenum:= numerator div denomenator;
  end;

function get1prob(*i,j,k,l,eqindex: integer): real*);
   var p,q,r,answer: real;
   begin
      answer:= 0.0;
      p := ((rho^[i,j] * rho^[k,l]));
      q := ((rho^[i,k] * rho^[j,l]));
      r := ((rho^[i,l] * rho^[j,k]));
      case eqindex of
       1: calcstat(i,l,j,k,abs(p-q),answer,1);
       2: calcstat(i,k,j,l,abs(r-p),answer,2);
       3: calcstat(i,j,k,l,abs(q-r),answer,3);
      end;
      get1prob:= answer;
   end;

(****************************)
(* from eqs *)

function pos(*c: char; name: inbuf): integer*);
var i: integer;
begin
     i := 1;
     repeat
         if name[i] = c then pos := i
         else i := i + 1;
     until (name[i] = c) or (i > buflength);
     if i > buflength then pos := 0;
end;


  (* strips extension from basename *)
procedure getbase(* var basename: inbuf *);
var i: integer;
begin
  i := 1;
  while not (basename[i] in [chr(0),'.']) do i := i + 1;
  basename[i] := chr(0);
end;


function getnamelength(*v: vertextype): integer*);
 var i: vertextype;
 begin
  i:= 0;
  repeat 
   i:= i+1;
  until (i > namelength) or not alphanumeric(vernames[v][i]);
  getnamelength:= i-1;
 end;

(*-----------#pc-version-----------------------------------------------------*)
(*end.*)
(*-----------#pc-version-----------------------------------------------------*)