(*-----------#pc-version-----------------------------------------------------*)
(*
implementation
uses io,util,rsutil,mon,sys,calctet;
*)
(*-----------#pc-version-----------------------------------------------------*)


(*-----------#unix-version-----------------------------------------------------*)
#include "syst.h"
#include "tt1.h"
#include "tt2.h"
#include "tt3.h"
#include "tt4.h"
#include "tt5.h"
#include "util.h"
#include "io.h"
#include "rsutil.h"
#include "cspecial.h"
#include "mon.h"
#include "sys.h"
#include "makemod.h"
#include "calctet.h"
(*-----------#unix-version-----------------------------------------------------*)

procedure getbayesfilename(var bfilename: inbuf; filecomplete:boolean);
  var changed: boolean;
  begin 
    bfilename := 'bayesfile|';
    if filecomplete then getfilename('Network file: | ',bfilename, changed)
      else getfilename('File that will contain template network: | ',bfilename, changed);
    if not changed then bfilename := 'bayesfile';
    twriteeoln(output);
  end;

procedure giveinstructions1;
  begin
    twriteeoln(output);
    twriteln(output,'TETRAD will write a file that contains|');
    twriteln(output,'a TETRAD readable nework with a default|');
    twriteln(output,'distribution.|');
    twriteeoln(output);
    twriteln(output,'You should edit the parameters of the distribution and save the file.|');
    twriteln(output,'Then you can read the file with the INPUT command.|');
    twriteeoln(output);
    twriteln(output,'The file containing the template is|');
    twrite(output,'named: |');
    putstr(ofilename,true);
    twriteeoln(output);
    twriteeoln(output);
  end;

procedure giveinstructions2;
  begin
    twriteeoln(output);
    twriteeoln(output);
    twrite(output,'The file containing this model is named: |');
    putstr(ofilename,true);
    twriteeoln(output);
    twriteln(output,'You can read the file into TETRAD with the INPUT command.|');
    twriteeoln(output);
  end;



procedure getbayesnet(var graph: adjtype; var cats: categoryarray; 
                      var eqs: eqorder; parmsfixed: boolean);
   var  filevar,bfin: text;
	i,j : integer;
   begin
     for j:= 1 to maxvertex do
         begin
           cats[j].num:= 2;
           for i:= 1 to maxcategories do cats[j].value[i] := i-1;
         end;
      twriteeoln(output);
      getcategories(cats);
      getbayesparms(cats,eqs,false,filevar);
      if parmsfixed then 
	begin
	giveinstructions1;
	writediscretemodel(cats,eqs,graph,ofilvar,true);
	end
      else 
	begin
	writediscretemodel(cats,eqs,graph,ofilvar,false);
	giveinstructions2;
	end;
      flush(ofilvar);
   end;  (* getbayesnet *)



procedure getdiscretemodel;
   begin
     twriteeoln(output);
     twrite(output,'Let TETRAD parameterize the Bayesian Network randomly [y] ?  |');
     parmsfixed:= (not compareto(yes));
     twriteeoln(output);
     new(varorder);
     formeqsorder(varorder,adjacency);
     getbayesnet(adjacency,cats,varorder,parmsfixed);
  end;  (* getparms *)

(* End of Getting the parameters for discrete data  *)
(****************************************************)

(*****************************)
(* Getting the Linear Model  *)

procedure fillexogd(* i: vertextype; ptype: probrange; parm1, parm2: real *);
  begin            
    exogd[i].probtype:=  ptype;
    exogd[i].parm1:=  parm1;
    exogd[i].parm2:=  parm2;
  end;


procedure getdist(var probtype: probrange;var parm1,parm2:real);
  var mean,variance,upper,lower,median,logvar:real;
   begin
     mean:= 0; variance:= 1; probtype:= 2; 
     lower:= 0; upper:= 1; median := 2;
     logvar := 2;
     twrite(output,'Uniform  = 1     |');
     twrite(output,'Normal = 2     |');
(*     twriteln(output,'LogNormal = 3|'); *)
     twriteeoln(output);
     probtype := tround(getnumber(1,2, true, 'Distribution: |', probtype));
     case probtype of
       1: begin
            parm1:= getnumber(-1000, 1000, true, 
               'The lower bound of the uniform interval: |  ', lower); 
            parm2:= getnumber(parm1, 1000, true,'The upper bound: | ', upper);
           end; (* case 1 *)
       2: begin
            parm1 := getnumber(-1000, 1000, true, 'Mean: | ', mean); 
           parm2 := getnumber(0.000001, 1000, true, 'Variance: | ', variance);
          end; (* case 2*)
       3: begin
            parm1 := getnumber(0.000001, 100, true, 'Median: | ', median); 
            parm2 := getnumber(0.000001, 1000, true,'Variance: | ',logvar); 
          end; (* case 3*)
     end; (* case *)
   end; (* getdist *)

procedure getdistforexog(var exogd: exogarray);
   var
      i:vertextype;
      probtype:probrange;
      parm1,parm2:real;

  begin
    twriteln(output,'Getting distribution for each variable.|');
    for i:= 1 to max do
      begin
        twriteeoln(output);
	twrite(output,'Distribution on the error term for |');
	writename(i,output);
        twriteeoln(output);
	getdist(probtype,parm1,parm2);
	fillexogd(i,probtype,parm1,parm2);
       end;
  end; (* getdistforexog *)

 procedure getprobassumpts;
    var standard,iid: boolean;
	parm1,parm2:real;
        probtype: probrange;
        i: vertextype;
      begin
        twriteeoln(output);
        twrite(output,'Do you want all error terms to have the same distribution? [y] |' );
        iid:= compareto(yes);
        twriteeoln(output);
        if (not iid) then getdistforexog(exogd)
        else
          begin
		twrite(output,'Error terms ~N(0,1)? [y] |' );
        	standard:= compareto(yes);
	        twriteeoln(output);
        	if (not standard) then
	           begin
			getdist(probtype,parm1,parm2);
        	        for i:= 1 to maxvertex do fillexogd(i,probtype,parm1,parm2);
	          end (* iid *)
		else for i:= 1 to maxvertex do fillexogd(i,2,0,1);
          end; (* standard *)
      end; (* getprobassumpts *)


  (* this prompts the user to specify the range in absolute value of the 
     linear coefficients, as well as the proportion of them that are negative. *)
procedure getparmrange(var percentneg:integer; var lowparm,highparm: real);
   begin
     twriteeoln(output);
     repeat
          lowparm := getnumber(0, 99, false, 
                   'Lower bound for absolute value of parameters: |', lowparm); 
          highparm := getnumber(0, 100, false, 
                         'Upper bound for absolute value of parameters: |', highparm); 
          if (highparm <= lowparm) then
           twriteln(output,'The upper bound must be higher than the lower bound.|');
    until (highparm > lowparm);
    twriteeoln(output);
    twrite(output,'Approximate percentage of pseudo-randomly selected|');
    twriteeoln(output);
    percentneg := tround(getnumber(0, 100, false,
                   'parameters made negative: |', percentneg)); 
  end; (* getparmprefs  *)

procedure getrandparms(var mat: covarray; var graph: adjtype);
  var i,j : vertextype;
       parmrange : real;
  begin 
      parmrange := highparm - lowparm;
      for i:= 1 to origmax do
         for j:= 1 to origmax do
            if (i in graphvertices) and (j in graphvertices) then 
               begin
                  if (graph^[i,j] <> notthere) and (mat^[i,j] = 0) then
                      begin
                         mat^[i,j] :=  (parmrange * thisrand) + lowparm;
                         if (thisrand <= (0.01 * percentneg)) then mat^[i,j] := 
  		             -1 * mat^[i,j];
                      end;
                end;
  end; (* getrandparms *)


(********************************************)
(* READLINEARMODEL                          *)

function getprobtype: probrange;
  var word,w1,w2,w3,n1,n2,n3: wordtype;
  begin
    getprobtype:= 4;
    w1:= 'uniform'; n1:= '1    ';
    w2:= 'normal'; n2:= '2    ';
    w3:= 'lognormal'; n3:= '3    ';
    readword(word);
    if matchword(word,w1,4) or matchword(word,n1,4) then
       getprobtype:= 1;
    if matchword(word,w2,4) or matchword(word,n2,4) then
       getprobtype:= 2;
    if matchword(word,w3,4) or matchword(word,n3,4) then
       getprobtype:= 3;
  end;

procedure readlinearmodel(*var linmodf:text *);
   label 999;
   var
      i,j:vertextype;
      cause,effect: vertextype;
      variableline,modelline: wordtype;
      parm1,parm2:real;
      probtype:probrange;
      causename:vertexnametype;
      wasinserted,finished,stop:boolean;
  begin
    readfileline(linmodf,buf);     
    stop := false;
    while (not stop) and (not eof(linmodf)) and (not (fatal in errors)) do
     begin
       readfileline(linmodf,buf);
       readwhitespace;
       if (not myeoln) then
	   begin
              readname(causename,fatal);
              if (fatal in errors) then goto 999;
	      cause := listposition(causename,false,vernames,wasinserted);
              if (ignoreall in errors) then goto 999;
              probtype:= getprobtype;
(*	      probtype := tround(readnum(false,fatal));  *)
	      if (probtype < 1) or (probtype > 3) then
	        myerror('Distribution type out of range.|',
				   fatal,true);
   	      parm1 := readnum(false,fatal);
              case probtype of
                 1,2: ;
                 3: if parm1 <= 0.0 then
                      myerror('Median cannot be <= 0.|',fatal,true);
              end;
	      parm2 := readnum(false,fatal);
              case probtype of
                 1: if parm2 <= parm1 then
                      myerror('Upper bound must exceed lower bound.|',
                               fatal,true);
                 2: if parm2 <= 0.0 then 
                      myerror('Variance cannot be <= 0.|',fatal,true);
                 3: if parm2 <= 0.0 then
                      myerror('Median cannot be <= 0.|',fatal,true);
              end;
	      fillexogd(cause,probtype,parm1,parm2);
            end
        else stop := true;
     end;
    havereadlinearmodel:= true;
999: end;

(* END OF READLINEARMODEL                   *)
(********************************************)



procedure writelinearmodel2(*cureqs:eqorder;var outputfile:text;
				adjacency:adjtype; mat:covarray*);
   var cause, effect,vertex: integer; written: vertexset; i,j: vertextype;
   begin
      written := [];
      twriteln(outputfile,'/graph|');
      for i:= 1 to max do
         for j:= 1 to max do
            if (adjacency^[i,j] <> notthere) then
                begin
                   pshort(i,outputfile);
                   twrite(outputfile,'  |');
                   pshort(j,outputfile);
                   twrite(outputfile,'  |');
		   tpwritereal(outputfile, parm^[i,j],10,decpoints,false);
                   twriteeoln(outputfile); 
                   written := written + [i,j];
      	        end;
      for i := 1 to max do if (i in graphvertices) and 
             (not (i in written)) then
         begin
             pshort(i,outputfile); 
             twriteeoln(outputfile); 
         end;
      twriteeoln(outputfile);
      twriteln(outputfile,'/linearmodel|');
      twriteln(outputfile,'Variable   Dist. Type      Parameters|');
      for vertex := 1 to origmax do
       if (vertex in graphvertices) then
	begin
          twrite(outputfile,'   |');
	  pwritename(vertex,outputfile,6);
          case exogd[vertex].probtype of
            1: twrite(outputfile,'    Uniform      |');
            2: twrite(outputfile,'    Normal       |');
(*             3: twrite(outputfile,'    Lognormal    |'); *)
          end;
(* 	  twriteint(outputfile,exogd[vertex].probtype); *)
	  tpwritereal(outputfile,exogd[vertex].parm1,8,decpoints,false);
	  twrite(outputfile,'     |');
	  tpwritereal(outputfile,exogd[vertex].parm2,8,decpoints,false);
	  twriteeoln(outputfile);
	end;
      twriteeoln(outputfile);
      flush(outputfile);
   end;

procedure getlinearmodel;
var changed,somenotset:boolean;
    ofile:text; i,j: vertextype;

  begin
    getprobassumpts;
    somenotset := false;
    for i := 1 to origmax do
      for j := 1 to origmax do
        if (adjacency^[i,j] <> notthere) and (parm^[i,j] = 0) then
           somenotset := true;
    if somenotset then 
      begin
        getparmrange(percentneg,lowparm,highparm);
        getrandparms(parm,adjacency);
      end;
   writelinearmodel2(varorder,ofilvar,adjacency,parm);
   giveinstructions2;
   flush(ofilvar);
  end;

 (* End of Getting the Linear Model  *)
 (************************************)


procedure createmodel;
label 999;
begin
   monteinit;
   if isacycle then 
         myerror('Makemod cannot generate cyclic models.|',fatal,false);
   if fatal in errors then goto 999;
   if prnton then twrite(output,'The TETRAD II Model Builder|');
   twriteeoln(output);
   twriteeoln(output);
   initrand(newseed);
   twriteln(output,'Create linear structural equation model (l),|');
   twrite(output,'or Bayesian network (b)? (l/b) [l]  |');
   undercontinuous:= compareto('l');
   if undercontinuous then getlinearmodel else getdiscretemodel;
   finishfile(ofilvar,ofilename);
999: end;

(*-----------#pc-version-----------------------------------------------------*)
(*end.*)
(*-----------#pc-version-----------------------------------------------------*)