#include "syst.h"
#include "tt1.h"
#include "tt2.h"
#include "tt3.h"
#include "tt4.h"
#include "tt5.h"
#include "cspecial.h"
#include "io.h"
#include "mon.h"
#include "util.h"
#include "rsutil.h"
#include "calctet.h"
#include "up.h"
#include "part.h"
#include "sys.h"


procedure setinterrupt;
begin
  aaabort := true;
end;


procedure writecname(*command:commandstring;var outfile:text*);
   var
	i:integer; stop: boolean;
   begin
	i:=1;
        stop := false;
	while (not stop) and (i<=commandlength) do 
         if (command[i]<>' ') then
	   begin
		twritechar(outfile,command[i]);
		i:=i+1;
	   end
         else stop := true;
   end;

procedure writename(*number:vertextype;var outfile:text*);
   var
	i:integer; stop: boolean;
   begin
        i := 1;
        stop := false;
	while (not stop) and (i<=namelength) and 
              (i <= getnamelength(number)) do
          if (vernames[number][i]<> ' ') then
	   begin
		twritechar(outfile,vernames[number][i]);
		i:=i+1;
	   end
          else stop := true;
   end;

procedure rswritename(*number:vertextype;var outfile:text; var thelength: integer*);
   var
	i:integer; stop: boolean;
   begin
	i:=1;
        stop := false;
	while (not stop) and (i<=namelength) and 
              (i <= getnamelength(number)) do
          if (vernames[number][i]<> ' ') then
	   begin
		twritechar(outfile,vernames[number][i]);
		i:=i+1;
	   end
          else stop := true;
        thelength:= thelength + (i - 1);
   end;

procedure pwritename(*number:vertextype;var outfile:text; thelength:integer*);
   var
	i:integer; stop: boolean;
   begin
	i:=1;
        stop := false;
	while  (not stop) and (i<=namelength) and 
               (i <= getnamelength(number)) do
          if (vernames[number][i]<> ' ') then
	   begin
		twritechar(outfile,vernames[number][i]);
		i:=i+1;
	   end
          else stop := true;
	while i<=thelength do begin twritechar(outfile,' '); i:= i+1; end;
   end;

procedure writevername(*name:vertexnametype;var outfile:text*);
   var
	i:integer; stop: boolean;
   begin
	i:=1;
        stop := false;
	while (i <= namelength) and (not stop) do 
          if name[i] <> ' ' then
	   begin
		twritechar(outfile,name[i]);
		i:=i+1;
	   end
          else stop := true;
   end;

function realmod(num,divisor:real):integer;
var i,temp: real;
begin
   if (divisor > num) then realmod := 0
   else if ((num < 0) or (divisor < 0)) then realmod :=0
   else 
     begin
	i:=0;
        temp := 0;
	while temp <= num do 
            begin
               i := i + 1;
               temp := i * divisor;
            end;
	if i > 9 then realmod := 9 else 
	if i = 0 then realmod := 0 else realmod := round(i - 1);
     end;
end;

{function expo(base,exponent:integer):real;
var temp1: real;
begin
  if base=0 then expo:= 0
  else if exponent=0 then expo:= 1
  else if exponent < 0 then expo := (1 / expo(base, (-1 * exponent)))
  else
     begin
       temp1 := expo(base,exponent - 1);
       expo := base * temp1;
     end;
end;}

function expo(base,exponent:integer):real;
var temp: real; i: integer;
begin
  if base=0 then temp:= 0
  else if exponent=0 then temp:= 1
  else if exponent > 0 then
     begin
        temp := 1;
        for i := 1 to exponent do temp := temp * base;
     end
  else 
     begin
        temp := 1;
        for i := -1 downto exponent do temp := temp/base;
     end;
  expo := temp;
end;

procedure tstr(*num: integer; var numstr: inbuf*);
var i,stringpos,j: integer; reversed: inbuf;
    isneg:boolean;
begin
   isneg := false;
   if num < 0 then begin  isneg := true; num := (-1 * num); end;
   for i := 1 to buflength do 
     begin
        numstr[i] := chr(0);
	reversed[i] := chr(0);
     end;
   i := 0;
   while num > 0 do
      begin
         i := i + 1;
         reversed[i] := chr(ord('0') + num mod 10);
         num := num div 10;
      end;
   if (i=0) and (num=0) then begin i := i + 1; reversed[i]:='0'; end;
   stringpos := 1;
   if isneg then
	begin
	   numstr[stringpos]:='-';
	   stringpos := stringpos + 1;
	end;
   for j := i downto 1 do
	begin
	   numstr[stringpos] := reversed[j];
	   stringpos := stringpos + 1;
	end;
   numstr[stringpos]:=chr(0);
end;
procedure tconcat(* thename,extension: inbuf; var result: inbuf *);
var i,j: integer;
begin
 i := 0;
 j := 1;
 repeat 
    i := i + 1;
    result[i] := thename[i];
 until (thename[i] = chr(0)) or (thename[i] = ' ') or (thename[i] = '|') or 
       (i = buflength);
 while (extension[j] <> ' ') and (not (extension[j] in [chr(0),' ']))
        and (j <= buflength) and (not aaabort) do 
            begin
               if i <= buflength then result[i] := extension[j]
               else myerror('File name is too long',fatal,false);
               i := i + 1;
               j := j + 1;
            end;
  result[i] := chr(0);
end;


procedure twritetf(*var ofile:text;tf:boolean*);
begin
   if gui then
	begin
		{write to gui buffer}
	end
   else
   if tf then twrite(ofile,'YES|')
	else twrite(ofile,'NO|');
end;


procedure twritespaces(*var ofile:text;numspaces:integer*);
var i :integer;
begin
   if gui then
	begin
		{write to gui buffer}
	end
   else
   for i := 1 to numspaces do
	twritechar(ofile,' ');
end;

procedure twrite(*var ofile:text;tstring:inbuf*);
var notover: boolean; t: integer;
begin
   if gui then
	begin
	  {write to gui buffer}
	end
   else
     begin
	notover := true;
	t := 1;
	while (t <= buflength) and notover do
	  begin
             if (tstring[t] <> chr(0)) and (tstring[t] <> eos) then
                begin
		   twritechar(ofile,tstring[t]);
		   t := t + 1;
	        end
                else notover := false;
           end;  { while }      
      end; {if then ELSE}
end;

procedure twriteln(*var ofile:text;tstring:inbuf*);
var notover: boolean; t: integer;
begin
   if gui then
	begin
	  {write to gui buffer}
	end
   else
     begin
	notover := true;
	t := 1;
	while (t <= buflength) and notover do
	  begin
             if (tstring[t] <> chr(0)) and (tstring[t] <> eos) then
                begin
		   twritechar(ofile,tstring[t]);
		   t := t + 1;
	        end
                else notover := false;
           end;  { while }      
	twriteeoln(ofile);
      end; {if then ELSE}
end;


{If too long will simply write out whole string}
procedure tpwrite(*var ofile:text;tstring:inbuf;length:integer;padleft:boolean*);
var stringlength:integer;
begin
   stringlength:=tstringlength(tstring);
   if gui then
	begin
	  {write to gui buffer}
	end
   else
     begin
	if stringlength > length then twrite(ofile,tstring)
	else if padleft then
	   begin
		twritespaces(ofile,length - stringlength);
		twrite(ofile,tstring);
	   end
	else
	   begin
		twrite(ofile,tstring);
		twritespaces(ofile,length - stringlength);
	   end;
     end;
end;

procedure twritechar(*var ofile:text;tchar:char*);
var notover: boolean; t: integer;
begin
   if gui then
	begin
	  {write to gui buffer}
	end
   else
        begin
	   write(ofile,tchar);
(*           if ioresult <> 0 then 
              myerror('Could not write to file.|',fatal,false);*)
        end;
end;


procedure twriteint(*var ofile:text;num:integer*);
var numstr:inbuf;
begin
   tstr(num,numstr);
   if gui then
	begin
	  {write to gui buffer}
	end
   else
     begin
	twrite(ofile,numstr);
     end;
end;

procedure tpwriteint(*var ofile:text;num:integer;length:integer;padleft:boolean*);
var numstr:inbuf;
begin
   tstr(num,numstr);
   if gui then
	begin
	  {write to gui buffer}
	end
   else
	tpwrite(ofile,numstr,length,padleft);
end;

procedure twritereal(*var ofile:text;realnum:real*);
var numstr : inbuf;
begin
	trealstr(realnum, numstr,102,4);
	twrite(ofile,numstr);
end;

procedure tpwritereal(*var ofile:text; realnum:real; length,decimal:integer;padleft:boolean*);
var numstr:inbuf;
begin
	trealstr(realnum, numstr,length+2,decimal);
	tpwrite(ofile,numstr,length,padleft);
end;

function goon(orignum: real):boolean;
begin
  if orignum < 0 then orignum := -1 * orignum;
  while orignum > 1 do orignum := orignum / 10;
  goon := orignum - trunc(orignum) > 0.5;
end;

procedure trealstr(*num:real;var numstring:inbuf;length,decimal:integer*);
var isneg,keepgoing:boolean; tnum:real;
    i,j,k,stringpos,nummod,numdigits,temp: integer; 
    t1,t2,t3,orignum:real;
begin
   orignum := abs(num);
   isneg := false;
   if num < 0 then begin  isneg := true; num := (-1 * num); end;
   for i := 1 to buflength do 
     begin
        numstring[i] := chr(0);
     end;
   numdigits := 0;
   tnum := num;

   (* calculate the number of digits to the left of the decimal
      adding an extra place for a minus sign			*)
   while (tnum >= 1) do
      begin
         numdigits := numdigits + 1;
         tnum := tnum / 10;
      end;
   if numdigits = 0 then numdigits := 1;
   stringpos := 1;
   length := length - 1;
   if isneg then
        numstring[stringpos]:='-'
	else numstring[stringpos]:=' ';

   if (numdigits + decimal +1) >length then
	begin
	   decimal:= length - numdigits - 1;
	   if decimal < 0 then decimal := 0;
	end;
   for j := numdigits downto (-1 * decimal) do
	begin
	   stringpos:= stringpos + 1;
	   tnum := expo(10, (j - 1));
	   nummod:= realmod(num, tnum);
	   num := num - (tnum * nummod);
	   if (j = 0) and (decimal > 0) then 
		begin
		numstring[stringpos]:='.';
		stringpos := stringpos + 1;
		numstring[stringpos]:=chr(ord('0') + nummod);
		end
	   else if (j <> 0) then numstring[stringpos]:=chr(ord('0') + nummod);
	end;
    if decimal = 0 then keepgoing := goon(orignum)
    else keepgoing := (ord(numstring[stringpos]) - ord('0') > 5);
    j := stringpos - 1;
    while keepgoing and (j > 1) do
       begin
         if not (numstring[j] in ['0'..'9','.']) then keepgoing := false
         else if (numstring[j] <> '.') then
            begin
               if (numstring[j] = '9') then 
                  begin
                     numstring[j] := '0';
                     if j = 2 then
		       begin
                          for k := buflength-1 downto 1 do
                              numstring[k+1] := numstring[k];
		          numstring[2] := '1';
                        end
                   end			       
               else
                 begin
                  numstring[j] := chr(ord(numstring[j]) + 1);
                  keepgoing := false;
                 end
             end;
         j := j - 1;
        end;
     numstring[stringpos]:='|';
(*     numstring[0] := chr(stringpos); *)
end;

function tstringlength(*tstring:inbuf):integer;*);
var t:integer;
begin
   t := 1;
   while (t <= buflength) and (tstring[t] <> chr(0))
        and  (tstring[t] <> eos) do
	t := t + 1;
   tstringlength:= t-1;
end;

procedure twriteeoln(*var ofile:text*);
begin
   if gui then
	begin
	  {write to gui buffer}
	end
   else
      begin
	writeln(ofile);
        if pageon then 
           begin
             outline := outline + 1;
             if outline mod 24 = 0 then
               begin
                  twrite(output,'Press <CR> to continue.|');
                  readln(input);
                  writeln(output);
                  outline := 1;
               end;
            end;
       end;
end;
(***************************************************)
(* END of tetrad write function                    *)
(***************************************************)

procedure resetfile(* var thefile: text; var ifilename: inbuf;
		    filekind: filetype *);
(* Opens thefile for reading. *)
label 999;
var errorno: byte; i: integer; 
begin
{ close(thefile); }
{ errorno := ioresult;}
 fileexists[filekind] := false;
 repeat
   errorno := 0;
   if (ifilename = blankfilename) or (ifilename = nullfilename) then
          readfilename(ifilename);
   if (ifilename = blankfilename) or (ifilename = nullfilename) then
       begin
          errors := errors + [fatal];
          goto 999;
       end;
   if filethere(ifilename) then 
       begin
          if ifilename = ofilename then 
             begin
               ofilename := blankfilename;
               errormess('Closing output file |',warning,false);
               writebuf(ifilename,output);
               twriteeoln(output);
             end;
          reset(thefile,ifilename);
	  fileexists[filekind] := true;
       end
   else
      begin
         errorno := 1;
	{function scrapped         editerr(1);}
         ifilename := nullfilename;
         twrite(output,'Enter new input file name: |'); 
	 readttyline(buf);
	 if buf[1] = chr(0) then 
	    begin
	       errors := errors + [fatal];
	       goto 999;
	    end;
      end;
 until errorno = 0;
999: ;
end;

procedure add0atend(var ifilename: inbuf);
var i: integer;
begin
   i := 1;
   while (i <= buflength) and (not (ifilename[i] in [' ','	',chr(0),eos])) do
      i := i + 1;
   if (i > buflength) then ifilename[buflength] := chr(0)  
   else ifilename[i] := chr(0);
end;

procedure rewritefile(* var thefile: text; var ofilename: inbuf *);
(* opens the file for writing. *)
label 999;
var ok,alreadythere,rewriteit: boolean; c: char; errorno: byte; i: integer;
begin
 ok := false;
 repeat
  if (ofilename = blankfilename) or (ofilename = nullfilename) then 
      readfilename(ofilename);
  if (ofilename = nullfilename) or (ofilename = blankfilename) then
          goto 999;
  alreadythere := filethere(ofilename);
  if alreadythere then
      begin
         twrite(output,'File |');
         i := 1;
         while (ofilename[i] <> chr(0)) and (i <= buflength) do 
                  begin
                     twritechar(output,ofilename[i]);
                     i := i + 1;
                  end;
         twrite(output,' already present.  Do you wish to replace it? [n] |');
         rewriteit := not compareto('n');
         if rewriteit then
	     begin 
		 rewrite(thefile,ofilename); 
	         errorno := 0;
             end
          else
	     begin
	         errorno := 1;   
		 goto 999;
  	     end;
       end
    else 
       begin
	   rewrite(thefile,ofilename); 
           errorno := 0;
       end;  
999: if errorno <> 0 then
        begin
          ofilename := nullfilename;
	  twrite(output,'Enter new file name: |');
	  readttyline(buf);
	  if myeoln then errorno := 0; 
        end;
   until errorno = 0; 
end;

procedure sysinit;
var i: integer;
begin
   runcommands := [finalsets .. partial,prttr,compareedge,correlations,scales,
                   purify,estimate,monte,gibbs,lrt,updatethenet,makemodel,
                   statwriter,split,cross,rocfile,regress,cequiv];
   switchcommands := [];
   commandcommands := [finalsets..null,prttr,setparameters..adepth,
                       addedges..covariance,significance,lly,mmy,mly,lmy,
                       aweight,apercent,adepth,addedges,graph,parameters,
                       acyclica,ndepth,removeedges,prttr,estimate,
                       singleconnection,nocommon,showprogress,forbidden,
                       required,addval,removeval,removeallval,common,values,
                       updatethenet,readcon,makemodel,readlinear,initial,
                       testmonte,testsearch,testbuildm,testbuildl,randgraph,
                       independence,listvars,decimals,split,cross,rocfile,regress,
                       means,cequiv,lambdac];
   ttycommands := commandcommands - [showprogress,covariance,cellcounts,graph,
                    independence,parameters,raw,values,readcon,initial];
   knowcommands := [significance,lly,mmy,mly,lmy,aweight,apercent,adepth,
                    addedges,acyclica,ndepth,removeedges,prttr,setparameters,
                    raw,graph,parameters,addtemp,cellcounts,showprogress,
                    removetemp,covariance,singleconnection,nocommon,null,values,
                    forbidden,required,addval,removeval,common,removeallval,
                    readlinear,initial,readcon,independence,decimals,regress,means,
                    cequiv];
   datacommands := [covariance,raw,cellcounts,readcon,independence];
   loadcommand;	
   for i := 1 to buflength do 
       begin
         nullfilename[i] := chr(0);
         blankfilename[i] := ' ';
       end;
end;

procedure checkinterrupt;
begin
end;
function filethere(* var name: inbuf): boolean; *); 
(* returns true if file already exists, false otherwise *)
var jobfilenumber: integer;

begin
    add0atend(name);
    jobfilenumber := open(name,0);
    filethere := (jobfilenumber <> -1);
    jobfilenumber := close(jobfilenumber);
end;	(* function filethere *)

procedure readname(* var name: vertexnametype; err: errortype *);
var c: char; notwarned,foundwhitespace: boolean; i: integer;
begin
   for i := 1 to namelength do name[i] := ' ';
   foundwhitespace := false;
   notwarned := true;
   i := 1;
   while (not myeoln) and (not foundwhitespace) do
      begin
        readit(c);
	if i = 1 then
           if not alphabetic(c) then
               myerror('Non-alphabetic character beginning name. |',err,true)
           else name[i] := c
	else if (i <= namelength) then
          begin
           if (not alphanumeric(c)) and (not whitespace(c)) then
	       myerror('Non-alphanumeric character in name.|     ',err,true)
           else if (not whitespace(c)) then name[i] := c
           else foundwhitespace := true;
          end
        else 
            begin
               if notwarned and (not whitespace(c)) then
                  begin
                    errormess('Truncating name to |',warning,true);
                    writevername(name,output);
                    twriteeoln(output);
                   end;
               notwarned := false;
               if whitespace(c) then foundwhitespace := true;
            end;
        if (not foundwhitespace) then i := i + 1;
      end;
(*      name[0]:=chr(i - 1);*)
end;


procedure readfilename(* var thefile: inbuf *);
(* reads a file name from the tty and stores it in thefile. *)
var c: char; i: integer;
begin
   thefile := nullfilename;
   readwhitespace;
   i := 0;
   if not myeoln then 
      begin
	 repeat
               readit(c);
	       i := i + 1;
	       if not whitespace(c) then thefile[i] := c;
	 until (myeoln) or (i > buflength) or (whitespace(c));
	 readwhitespace;
         if not myeoln then
	    begin
	    twriteln(output,'Warning: File name truncated|');
	    end;
	 if (thefile[1] = ' ') or (thefile[1] = chr(0)) then
	    begin
	    	for i:=1 to buflength do thefile[i] := chr(0);
(* unix		thefile[0] := chr(buflength); *)
            end;
      end;  
end;


procedure readttyline(* var buf: inbuf *);
var k: integer; c: char;
begin
   if gui then
	getnextarg(buf)
   else
     begin
	   for k:=1 to buflength do buf[k] := chr(0);
	   k := 1;
	   if not eof then
		 while not eoln and (k <= buflength) do
		    begin
		       read(c);
		       buf[k] := c;
		       k := k + 1;
		    end;
	readln;
	end;
   curpos := 1;
end;
procedure getfilename(* prompt: inbuf; var filename: inbuf; 
		        var changed: boolean *);
begin
       putstr(prompt,true);
       if (filename <> blankfilename) and (filename <> nullfilename) then
           begin
	       twritechar(output,'[');
               putstr(filename,true);
               twritechar(output,']');
	   end;
       readttyline(buf);    
       changed := not myeoln;  
       if (buf = tabfilename) then filename := nullfilename
       else if not myeoln then readfilename(filename);
end;
procedure getname(*number:integer; letter:char; var result: inbuf*);
  begin
    result[1] := letter;
    if number <= 9 then
      begin
        result[2] := chr(ord('0') + number);
        result[3] := chr(0);
      end
    else
      begin
        result[2] := chr(ord('0') + number div 10);
        result[3] := chr(ord('0') + number mod 10);
        result[4] := chr(0);
      end;
   end;

procedure errormess(* message: inbuf; err: errortype; showpos: boolean *);
(* this procedure records that err has occurred
   by adding it to the error set.  it tells what action tetrad is going
   to take; if the error occurred in a file the name of the file and the
   line number on which the error occurred; prints out the line on which
   the error occurred; points to where in the line the error occurred;
   an explanation of what the error was (from message). *)

var t: integer;
begin
   errors := errors + [err];
   if err = stopprog then wantexit := true;
   if err = fatal then twrite(output,'Fatal error: |') else twrite(output,'Warning: |');
   if (err = ignoreall) then twrite(output,'input being ignored|');
   if (lineno <> 0) and (currentin <> inp) then
         begin
            twrite(output,' on line |');
	    twriteint(output,lineno);
	    twrite(output,' of |');
            putstr(curfilename,true);
         end;
   if (currentin <> inp) and (lineno = 0) then 
       begin
          twrite(output,' in |'); putstr(curfilename,true); twriteln(output,': |');
       end
   else writeln;
   t := 1;
   if ((currentin <> inp) or showpos) and (lineno <> 0) then 
	 begin
	    while (buf[t] <> chr(0)) and (t <= buflength) do
	       begin
	          twritechar(output,buf[t]);
		  t := t + 1;
	       end;
	    if showpos then
	       begin
	          twriteeoln(output);
		  for t:=1 to curpos-2 do twritechar(output,' '); twritechar(output,'^');
	       end
	    else twriteeoln(output);
	 end;
   t := 1;
   while (message[t] <> chr(0)) and (message[t] <> '|') do
      begin
         twritechar(output,message[t]);
	 t := t + 1;
      end;
   if (err = ignorepart) then twrite(output,'  Rest of line ignored.|');
end;

(* MEMORY SECTION **********************)

function heapavail(* : longint *);
begin
    (* dummy in unix *)
(*    heapavail := maxavail;*)
heapavail:=10000000;
end;

procedure datamatinit;
var i: integer; size: word;
begin
   size := maxsamp * sizeof(vertarrptr);
   if size < heapavail then
        new(datamat) 
   else errormess('Out of memory: Datamat|',fatal,false);
   if (not (fatal in errors)) then for i:= 1 to maxsamp do datamat^[i] := nil;
end;

procedure initdatamat(* sampsize: integer *);
label 999;
var i: integer;
begin
   for i := 1 to tround(sampsize) do
      if (datamat^[i] = nil) and (not (fatal in errors)) then
        if sizeof(vertexarray) < heapavail then new(datamat^[i])
        else errormess('Out of memory: Sample size too large.|',fatal,false);
   if fatal in errors then sampsize := 0.0;
   i := tround(sampsize) + 1;
   while  (i <= maxsamp) and (datamat^[i] <> nil) do
      begin
          dispose(datamat^[i]);
          datamat^[i] := nil;
          i := i + 1;
      end;
999: end;

procedure printbigdata(x,y: integer);
begin
   writeln(datamat^[x]^[y]);
end;

function getbigdata(*x,y:integer): catrange;*);
begin
	getbigdata:= datamat^[x]^[y];
end;

procedure setbigdata(*x,y,value:integer*);
begin
  if (x <= maxsamp) and (y <= maxvertex) and (value <= maxcategories) then
     datamat^[x]^[y]:= value
  else errormess('Sample data cannot be stored.|',fatal,false);
end;

(* END OF MEMORY SECTION **********************)

(* ARGUMENT SECTION ******************)

function numberofargs(*:integer;*);
begin
	numberofargs := argc - 1 ;
end;

procedure setupargs;
begin
	maxargnum := numberofargs;
	currentargnum := 1;
	if maxargnum > 0 then gui := true
	else gui := false;
end;

procedure getnextarg(*var buf:inbuf*);
var k : integer;
begin
	if currentargnum <= maxargnum
	then
	   begin
		argv(currentargnum,buf);
		for k := 1 to buflength do
			if buf[k] = ' ' then buf[k] := chr(0);
		replacecharwithspace('#');
		replacecharwithchar('!','|');
		currentargnum := currentargnum + 1;
		putstr(buf,true);
		twriteeoln(output);
	   end;
end;	

(* END OF ARGUMENT SECTION ******************)

function tgettime(*:double;*);
begin
	tgettime:=gettime;
end;

procedure putstr(* mess: inbuf; totty: boolean *);
var notover: boolean; t: integer;
begin
     notover := true;
     t := 1;
     while (t <= buflength) and notover do
       begin
          if (mess[t] <> chr(0)) and (mess[t] <> eos) then
	      begin
	  	if not totty then twritechar(ofilvar,mess[t]) 
		else twritechar(output,mess[t]);
		t := t + 1;
	      end
	  else notover := false;
       end;  { while }      
end;

procedure writebuf(*mess: inbuf; var outfile: text*);
var notover: boolean; t: integer;
begin
     notover := true;
     t := 1;
     while (t <= buflength) and notover do
       begin
          if (mess[t] <> chr(0)) then
	      begin
	  	twritechar(outfile,mess[t]);
		t := t + 1;
	      end
	  else notover := false;
       end;  { while }      
end;

procedure finishfile(*var ofile: text, var ofilename: inbuf*);
begin
   flush(ofile);
{   close(ofile);}
   fileexists[outputf]:=false;
   ofilename:=nullfilename;
end;

procedure getcomment(* var comment: inbuf *);
 begin
   twrite(output,'If you wish, enter a comment for the input file|');
   twriteeoln(output);
   twrite(output,'*|');
   readttyline(comment);
 end;

procedure readbayesnet(*var cats: categoryarray; var eqs: eqorder; 
                       var bfin: text; var graph: adjtype*);
label 999;
  var word: wordtype; localadj: adjtype; localnames: namearray;
     curvarname: vertexnametype;
     varnumber,i,j: vertextype;
     cause,effect: vertextype;
     match,wasinserted: boolean;
  begin
   disposebayesnet(cats);
   tnewadj(localadj,fatal);	(* check for enough space *)
   if fatal in errors then goto 999;
   if havereadgraph 
    then twriteln(output,'Erasing previous graph file.|');
   for i:= 1 to maxvertex do
     begin
      localnames[i] := blankname;
      for j:= 1 to maxvertex do localadj^[i,j]:= notthere;
    end;
   graphvertices := [];
   repeat (* read through the file to get graph structure and the
             order of the parents *)
     readfileline(bfin,buf);
     if isdashedline then 
       begin
         readfileline(bfin,buf);
         curpos:= 1;
         readwhitespace;
         readname(curvarname,ignoreall);
(*         if (not istheoretical(curvarname)) then  *)
            effect:= listposition(curvarname,true,localnames,wasinserted);
         graphvertices := graphvertices + [effect];
         readtochar(':'); 
         readwhitespace;
           (* if the var. is exogenous, it has no parents, in which
              case myeoln should be true *)
         if not myeoln then
           repeat
             readname(curvarname,ignoreall);
(*             if (not istheoretical(curvarname)) then   *)
             cause:= listposition(curvarname,true,localnames,wasinserted);
             graphvertices := graphvertices + [cause];
             localadj^[cause,effect] := there;
             readwhitespace;
           until myeoln;
       end; (* isdashedline *)
   until eof(bfin);
   rearrange(localadj,adjacency,localnames,vernames);
   dispose(localadj);
   isacycle := iscycle(adjacency);
   if isacycle then
       begin
         myerror('Graph is cyclic.|',fatal,false);
         goto 999;
       end;
   reset(bfin);
(*   if ioresult <> 0 then 
      begin
         myerror('Could not open file.|',fatal,false);
         goto 999;
      end;*)
   for i:=1 to maxvertex do
     begin
       if istheoretical(vernames[i]) then theoretical[i] := true;
       for j := 1 to maxvertex do 
          if graph^[i,j] <> notthere then 
             graphvertices := graphvertices + [i,j];
     end;
   findindependent(graph,independent);
   calcnum(numob,numtheo,max,vernames);
   formeqsorder(eqs, graph);
   reset(bfin);    
   lineno:=0;
(*   if ioresult <> 0 then 
      begin
         myerror('Could not open file.|',fatal,false);
         goto 999;
      end;*)
   readcategories(cats, eqs, bfin);
   getbayesparms(cats,eqs,true,bfin);
999: end;
